;*****WINCALLBACK***************************************************************
CALLBACKIT STRUC          ;main callback variable structure
 iSelBeg DD ?
 iSelEnd DD ?
CALLBACKIT ENDS

 .DATA
 SJTabBegin                                ;search/jump message table
 SJNTAB1 LABEL WORD
  SJTabEntry WM_CREATE,CREATE_WM           ;message table entry
  SJTabEntry WM_SETFOCUS,SETFOCUS_WM       ;message table entry
  SJTabEntry WM_SIZE,SIZE_WM               ;message table entry
  SJTabEntry WM_INITMENUPOPUP,INITMENUPOPUP_WM
  SJTabEntry WM_COMMAND,COMMAND_WM         ;message table entry
  SJTabEntry WM_CLOSE,CLOSE_WM             ;message table entry
  SJTabEntry WM_QUERYENDSESSION,QUERYENDSESSION_WM
  SJTabEntry WM_DESTROY,DESTROY_WM         ;message table entry
 messageFindReplace LABEL WORD
  SJTabEntry 07FFFH,MFREPLACE
 SJATAB1 LABEL WORD
 SJTENT1 EQU (SJATAB1-SJNTAB1)/WORD
 SJTabEnd SJTMIN,SJTMAX,CREATE_WM          ;total ent,min,max,ref

 SJTabBegin                                    ;search/jump command msg table
  CMDNTAB1 LABEL WORD
  SJTabEntry IDM_FILE_NEW,FILE_NEW_IDM         ;message table entry
  SJTabEntry IDM_FILE_OPEN,FILE_OPEN_IDM       ;message table entry
  SJTabEntry IDM_FILE_SAVE,FILE_SAVE_IDM       ;message table entry
  SJTabEntry IDM_FILE_SAVE_AS,FILE_SAVE_AS_IDM ;message table entry
  SJTabEntry IDM_FILE_PRINT,FILE_PRINT_IDM     ;message table entry
  SJTabEntry IDM_APP_EXIT,APP_EXIT_IDM         ;message table entry
  SJTabEntry IDM_EDIT_UNDO,EDIT_UNDO_IDM       ;message table entry
  SJTabEntry IDM_EDIT_CUT,EDIT_CUT_IDM         ;message table entry
  SJTabEntry IDM_EDIT_COPY,EDIT_COPY_IDM       ;message table entry
  SJTabEntry IDM_EDIT_PASTE,EDIT_PASTE_IDM     ;message table entry
  SJTabEntry IDM_EDIT_CLEAR,EDIT_CLEAR_IDM     ;message table entry
  SJTabEntry IDM_EDIT_SELECT_ALL,EDIT_SELECT_ALL_IDM ;message table entry
  SJTabEntry IDM_SEARCH_FIND,SEARCH_FIND_IDM   ;message table entry
  SJTabEntry IDM_SEARCH_NEXT,SEARCH_NEXT_IDM   ;message table entry
  SJTabEntry IDM_SEARCH_REPLACE,SEARCH_REPLACE_IDM ;message table entry
  SJTabEntry IDM_FORMAT_FONT,FORMAT_FONT_IDM   ;message table entry
  SJTabEntry IDM_HELP,HELP_IDM                 ;message table entry
  SJTabEntry IDM_APP_ABOUT,APP_ABOUT_IDM       ;message table entry
  CMDATAB1 LABEL WORD
  CMDENT1 EQU (CMDATAB1-CMDNTAB1)/WORD
 SJTabEnd CMDMIN,CMDMAX,FILE_NEW_IDM           ;min,max,ref

 .CODE
                         ;upon entry, the stack contains the following
                         ;ESP stack pointer -->return address
                         ;                     window handle
                         ;                     message number
                         ;                     wParam
                         ;                     lParam
WINCALLBACK:
 MOV EAX,[ESP+2*DWORD]   ;window message number from stack

; CMP EAX,SJTMAX          ;SJTMAX=highest window msg num in table
; JA DefWindowProcA       ;immediately jump to default handler



 PUSH EDI                ;save essential register
 MOV ECX,SJTENT1         ;number of entries in window message number table
 MOV EDI,@ SJNTAB1       ;window message number table address
 REPNE SCASW             ;search table for message number
 JZ @F                   ;zero flag set if found
 POP EDI                 ;restore essential register
 JMP DefWindowProcA      ;message not found--immediate jump to default handler
@@:
                         ;window message number has been found
 RPUSHIT ESI,EBP,EBX     ;save essential windows registers
 MOV ESI,[ESP+5*DWORD]   ;ESI=windows handle
 MOV EBX,[ESP+7*DWORD]   ;EBX=wParam
 MOV EDX,[ESP+8*DWORD]   ;EDX=lParam
 XOR EBP,EBP             ;EBP=0, valuable to PUSH EBP in handler routines
                         ;after the above instructions, the registers and stack
                         ;contain the following useful values:
                         ;ESI=window handle
                         ;EAX=window message number
                         ;EBX=wParam
                         ;EDX=lParam
                         ;EDI=index+4 of window message number table
                         ;EBP=0
                         ;now, ESP stack pointer -->old entry value of ESI
                         ;                          old entry value of EBP
                         ;                          old entry value of EBX
                         ;                          old entry value of EDI
                         ;                          return addr
                         ;                          windows handle
                         ;                          message number
                         ;                          wParam
                         ;                          lParam
 SUB ESP,CALLBACKIT      ;make main callback local variable space on stack

 MOVSX ECX,W[SJATAB1-SJNTAB1-WORD+EDI]
 ADD ECX,@ CREATE_WM
 JMP ECX

DEFWINRET:               ;return point to default winproc if needed
 ADD ESP,CALLBACKIT      ;recover local variable space on stack
 POPIT ESI,EBP,EBX,EDI   ;restore old entry values of essential registers
 JMP DefWindowProcA      ;for default message processing

MAINCBRET:               ;main callback return--welcome home
 ADD ESP,CALLBACKIT      ;recover main callback local variable space on stack

DIAGBOXRET:              ;dialog box return if needed
 POPIT ESI,EBP,EBX,EDI   ;restore old entry values of essential registers
 RET 4*DWORD             ;balance stack upon returning to windows

;*****END OF MAIN CALLBACK******************************************************
 .DATA
 SJTabBegin                              ;search/jump dialog message table
 DLGNTAB1 LABEL WORD
  SJTabEntry WM_INITDIALOG,INITDIALOG_WM ;message table entry
  SJTabEntry WM_COMMAND,COMMAND1_WM      ;message table entry
 DLGATAB1 LABEL WORD
 DLGENT1 EQU (DLGATAB1-DLGNTAB1)/WORD
 SJTabEnd DLGMIN,DLGMAX,INITDIALOG_WM    ;num tab,adr tab,total ent,min,max,ref

;******DLGPROC CALLBACK*********************************************************
 .CODE
                         ;upon entry, the stack contains the following
                         ;ESP stack pointer -->return address
                         ;                     window handle
                         ;                     message number
                         ;                     wParam
                         ;                     lParam
AboutDlgProc:
 MOV EAX,[ESP+2*DWORD]   ;dialog message number from stack
 PUSH EDI                ;save essential register
 MOV ECX,DLGENT1         ;number of entries in dialog message number table
 MOV EDI,@ DLGNTAB1      ;window message number table address
 REPNE SCASW             ;search table for dialog message number
 JZ @F                   ;zero flag set if found
 POP EDI                 ;restore essential register
 JMP DLGBK1              ;message not found--immediate jump to default handler
@@:
 RPUSHIT ESI,EBP,EBX     ;save essential windows registers
 MOV ESI,[ESP+5*DWORD]   ;ESI=windows handle
 MOV EBX,[ESP+7*DWORD]   ;EBX=wParam
 MOV EDX,[ESP+8*DWORD]   ;EDX=lParam
 XOR EBP,EBP             ;EBP=0, valuable to PUSH EBP in handler routines
                         ;after the above instructions, the registers and stack
                         ;contain the following useful values:
                         ;ESI=window handle
                         ;EAX=window message number
                         ;EBX=wParam
                         ;EDX=lParam
                         ;EBP=0
                         ;now, ESP stack pointer -->old entry value of ESI
                         ;                          old entry value of EBP
                         ;                          old entry value of EBX
                         ;                          old entry value of EDI
                         ;                          return addr
                         ;                          windows handle
                         ;                          message number
                         ;                          wParam
                         ;                          lParam
 MOVSX ECX,W[DLGATAB1-DLGNTAB1-WORD+EDI]
 ADD ECX,@ INITDIALOG_WM
 JMP ECX
;*****END OF DIALOGBOX CALLBACK*************************************************
